/*
 * Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana
 *
 * This file is part of blendb.
 *
 * blendb is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * blendb is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with blendb.  If not, see <http://www.gnu.org/licenses/>.
 */

import { expect } from "chai";

import { Tsort, TsortDep } from "./tsort";

describe("topological sorting utility library", () => {
    it("should sort the dependencies", () => {
        let deps: TsortDep[] = [
            {value: "dim:1", dependOf: "dim:0"},
            {value: "dim:2", dependOf: "dim:0"},
            {value: "dim:3", dependOf: "dim:1"},
            {value: "dim:4", dependOf: "dim:2"},
            {value: "dim:5", dependOf: "dim:3"},
            {value: "dim:5", dependOf: "dim:2"},
        ];
        let sorted = Tsort.dependencies(deps);
        let res: string[] = ["dim:0", "dim:2", "dim:4", "dim:1", "dim:3", "dim:5"];

        expect(res).to.be.a("array");
        expect(res).to.not.be.empty;
        for (let i = 0; i < sorted.length; ++i) {
            expect(sorted[i]).to.be.a("string");
            expect(sorted[i]).to.be.eql(res[i]);
        }
    });
});
